# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables

__all__ = ['LoadBalancerTarget']


class LoadBalancerTarget(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 label_selector: Optional[pulumi.Input[str]] = None,
                 load_balancer_id: Optional[pulumi.Input[int]] = None,
                 server_id: Optional[pulumi.Input[int]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 use_private_ip: Optional[pulumi.Input[bool]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Adds a target to a Hetzner Cloud Load Balancer.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_hcloud as hcloud

        my_server = hcloud.Server("myServer",
            server_type="cx11",
            image="ubuntu-18.04")
        load_balancer = hcloud.LoadBalancer("loadBalancer",
            load_balancer_type="lb11",
            location="nbg1")
        load_balancer_target = hcloud.LoadBalancerTarget("loadBalancerTarget",
            type="server",
            load_balancer_id=load_balancer.id,
            server_id=my_server.id)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ip: IP address for an IP Target. Required if
               `type` is `ip`.
        :param pulumi.Input[str] label_selector: Label Selector selecting targets
               for this Load Balancer. Required if `type` is `label_selector`.
        :param pulumi.Input[int] load_balancer_id: ID of the Load Balancer to which
               the target gets attached.
        :param pulumi.Input[int] server_id: ID of the server which should be a
               target for this Load Balancer. Required if `type` is `server`
        :param pulumi.Input[str] type: Type of the target. Possible values
               `server`, `label_selector`, `ip`.
        :param pulumi.Input[bool] use_private_ip: use the private IP to connect to
               Load Balancer targets. Only allowed if type is `server` or
               `label_selector`.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['ip'] = ip
            __props__['label_selector'] = label_selector
            if load_balancer_id is None and not opts.urn:
                raise TypeError("Missing required property 'load_balancer_id'")
            __props__['load_balancer_id'] = load_balancer_id
            __props__['server_id'] = server_id
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            __props__['use_private_ip'] = use_private_ip
        super(LoadBalancerTarget, __self__).__init__(
            'hcloud:index/loadBalancerTarget:LoadBalancerTarget',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ip: Optional[pulumi.Input[str]] = None,
            label_selector: Optional[pulumi.Input[str]] = None,
            load_balancer_id: Optional[pulumi.Input[int]] = None,
            server_id: Optional[pulumi.Input[int]] = None,
            type: Optional[pulumi.Input[str]] = None,
            use_private_ip: Optional[pulumi.Input[bool]] = None) -> 'LoadBalancerTarget':
        """
        Get an existing LoadBalancerTarget resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ip: IP address for an IP Target. Required if
               `type` is `ip`.
        :param pulumi.Input[str] label_selector: Label Selector selecting targets
               for this Load Balancer. Required if `type` is `label_selector`.
        :param pulumi.Input[int] load_balancer_id: ID of the Load Balancer to which
               the target gets attached.
        :param pulumi.Input[int] server_id: ID of the server which should be a
               target for this Load Balancer. Required if `type` is `server`
        :param pulumi.Input[str] type: Type of the target. Possible values
               `server`, `label_selector`, `ip`.
        :param pulumi.Input[bool] use_private_ip: use the private IP to connect to
               Load Balancer targets. Only allowed if type is `server` or
               `label_selector`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["ip"] = ip
        __props__["label_selector"] = label_selector
        __props__["load_balancer_id"] = load_balancer_id
        __props__["server_id"] = server_id
        __props__["type"] = type
        __props__["use_private_ip"] = use_private_ip
        return LoadBalancerTarget(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Output[Optional[str]]:
        """
        IP address for an IP Target. Required if
        `type` is `ip`.
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter(name="labelSelector")
    def label_selector(self) -> pulumi.Output[Optional[str]]:
        """
        Label Selector selecting targets
        for this Load Balancer. Required if `type` is `label_selector`.
        """
        return pulumi.get(self, "label_selector")

    @property
    @pulumi.getter(name="loadBalancerId")
    def load_balancer_id(self) -> pulumi.Output[int]:
        """
        ID of the Load Balancer to which
        the target gets attached.
        """
        return pulumi.get(self, "load_balancer_id")

    @property
    @pulumi.getter(name="serverId")
    def server_id(self) -> pulumi.Output[Optional[int]]:
        """
        ID of the server which should be a
        target for this Load Balancer. Required if `type` is `server`
        """
        return pulumi.get(self, "server_id")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Type of the target. Possible values
        `server`, `label_selector`, `ip`.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="usePrivateIp")
    def use_private_ip(self) -> pulumi.Output[bool]:
        """
        use the private IP to connect to
        Load Balancer targets. Only allowed if type is `server` or
        `label_selector`.
        """
        return pulumi.get(self, "use_private_ip")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

